package handler

import (
	"github.com/paulmach/orb"
	"time"
)

type RoutingService interface {
	Route(locations []orb.Point) (route *Route, err error)
}
type Route struct {
	Summary RouteSummary
	Legs    []RouteLeg
}

type RouteSummary struct {
	Polyline string
}
type RouteLeg struct {
	Distance float64
	Duration time.Duration
	Polyline string
}
